// Id3tagv2.h: CId3tagv2 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ID3TAGV2_H__92584511_76E1_4EE6_90A7_E196C9C0EF88__INCLUDED_)
#define AFX_ID3TAGV2_H__92584511_76E1_4EE6_90A7_E196C9C0EF88__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef	min
#undef	min
#endif
#ifdef	max
#undef	max
#endif


#if	0
static WORD ExtractI2(unsigned char buf[2])
{
	WORD x;
	// big endian extract
	x = buf[0];
	x <<= 8;
	x |= buf[1];
	return x;
}

static DWORD ExtractI4(unsigned char buf[4])
{
	DWORD x;
	// big endian extract
	x = buf[0];
	x <<= 8;
	x |= buf[1];
	x <<= 8;
	x |= buf[2];
	x <<= 8;
	x |= buf[3];
	return x;
}
#endif

struct id3_v23v22table_t {
	char *v23;
	char *v22;
};
extern id3_v23v22table_t id3_v23v22table[];

class MP3INFPEXTR_EXT CId3Frame
{
public:
	CId3Frame()
	{
		m_data = NULL;
		m_dwId = 0;
		m_dwSize = 0;
		m_wFlags = 0;
	};
	virtual ~CId3Frame()
	{
		Release();
	};
	void Release()
	{
		if(m_data)
		{
			free(m_data);
		}
		m_data = NULL;
		m_dwId = 0;
		m_dwSize = 0;
		m_wFlags = 0;
	}
	CId3Frame(const CId3Frame &obj)	//Rs[RXgN^
	{
		m_data = (unsigned char *)malloc(obj.m_dwSize);
		memcpy(m_data,obj.m_data,obj.m_dwSize);
		m_dwId = obj.m_dwId;
		m_dwSize = obj.m_dwSize;
		m_wFlags = obj.m_wFlags;
	};
	size_t LoadFrame2_4(unsigned char *pData,size_t dwSize);
	size_t LoadFrame2_3(unsigned char *pData,size_t dwSize);
	size_t LoadFrame2_2(unsigned char *pData,size_t dwSize);
	DWORD GetId(){return m_dwId;};
	void SetId(DWORD id){m_dwId = id;};
	size_t GetSize(){return m_dwSize;};
	void SetSize(DWORD size){m_dwSize = size;};
	WORD GetFlags(){return m_wFlags;};
	void SetFlags(WORD flags){m_wFlags = flags;};
	unsigned char *GetData(){return m_data;};
	void SetData(unsigned char *data,size_t size)
	{
		if(m_data)
		{
			free(m_data);
		}
		m_data = (unsigned char *)malloc(size);
		if(!m_data)
		{
			return;	//mۂłȂ
		}
		memcpy(m_data,data,size);
		m_dwSize = size;
	};
	bool	IsSame(const CId3Frame &obj) const {	// 2010/09/26() 08:59:08 {Tiki}
		return	m_dwId == obj.m_dwId && m_dwSize == obj.m_dwSize && m_wFlags == obj.m_wFlags && memcmp(m_data, obj.m_data, std::min(m_dwSize, obj.m_dwSize)) == 0;
	}

private:
	unsigned char	*m_data;
	DWORD	m_dwId;
	size_t	m_dwSize;
	WORD	m_wFlags;
};

#pragma	warning(disable: 4251)	// class  __export L[[hg class ɃGNX|[gĂB
#include <map>


//////////////////////////////////////////////////////////////////////////////
/**


*/
class MP3INFPEXTR_EXT CId3tagv2
{
public:
#pragma pack(1)
	typedef struct _ID3HEAD
	{
		char id3des[3];
		char ver[2];
		unsigned char flag;
		unsigned char size[4];
	}ID3HEAD;
#pragma pack()
//	CId3tagv2(WORD defaultVersion = 0x0300/* ID3v2.3 = 0x0300/ID3v2.4 = 0x0400*/);
	CId3tagv2();
	virtual ~CId3tagv2();
	void SetEncDefault(LPCTSTR szDefaultEnc);
	BOOL IsEnable(){return m_bEnable;};
//	void SetDefaultId3v2Version(DWORD version){m_wDefaultId3TagVersion = (WORD )version;};/* ID3v2.3 = 0x0300/ID3v2.4 = 0x0400*/
	void SetVer(WORD ver){m_wVer = ver;};
	WORD GetVer(){return m_wVer;};
	void SetCharEncode(int encode)
	{
		// GR[hw$2/$3ĝv2.4ȍ~
		if(m_wVer < 0x0400)
		{
			if(	(encode != ID3V2CHARENCODE_ISO_8859_1) &&
				(encode != ID3V2CHARENCODE_UTF_16) )
			{
				// ISO-8859-1Ɏݒ
				encode = ID3V2CHARENCODE_ISO_8859_1;
			}
		}
		m_encode = encode;
	};
	int GetCharEncode(){return m_encode;};
	void SetUnSynchronization(BOOL bEnable){m_bUnSynchronization = bEnable;};
	BOOL GetUnSynchronization(){return m_bUnSynchronization;};

	static const int	ID3V2CHARENCODE_ISO_8859_1;
	static const int	ID3V2CHARENCODE_UTF_16;
	static const int	ID3V2CHARENCODE_UTF_16BE;
	static const int	ID3V2CHARENCODE_UTF_8;

	TEString GetTitle();	//TIT2
	void SetTitle(LPCTSTR title);
	TEString GetTrackNo();
	void SetTrackNo(LPCTSTR szTrackNo);
	TEString GetArtist();
	void SetArtist(LPCTSTR artist);
	TEString GetAlbumArtist();
	void SetAlbumArtist(LPCTSTR albumartist);
	TEString GetAlbum();
	void SetAlbum(LPCTSTR album);
	TEString GetYear();
	void SetYear(LPCTSTR year);
	TEString GetGenre();
	void SetGenre(LPCTSTR szGenre);
	TEString GetComment();
	void SetComment(LPCTSTR comment);
	TEString GetComposer();
	void SetComposer(LPCTSTR composer);
	TEString GetOrigArtist();
	void SetOrigArtist(LPCTSTR origArtist);
	TEString GetCopyright();
	void SetCopyright(LPCTSTR copyright);
	TEString GetUrl();
	void SetUrl(LPCTSTR url);
	TEString GetEncoder();
	void SetEncoder(LPCTSTR encoder);
	TEString GetEncodest();
	void SetEncodest(LPCTSTR encoder);

	DWORD Load(LPCTSTR szFileName, unsigned __int64 ofst);	// ofst for DSD. 2012/08/21() 21:13:56 {Tiki}
	DWORD Save(LPCTSTR szFileName);
	DWORD DelTag(LPCTSTR szFileName);
	DWORD MakeTag(LPCTSTR szFileName);

	std::multimap<DWORD, CId3Frame>	&GetMap() {
			return	m_frames;
	}
	const	std::multimap<DWORD, CId3Frame>	&GetMap() const {
			return	m_frames;
	}
	void	SetPaddingSize(int nPad) {
		ID3V2_PADDING_SIZE	= nPad;
	}
	int		GetPaddingSize() const {
		return	ID3V2_PADDING_SIZE;
	}

private:
	size_t DecodeUnSynchronization(unsigned char *data,size_t dwSize);
	size_t EncodeUnSynchronization(unsigned char *srcData,size_t dwSize,unsigned char *dstData);
	DWORD ExtractV2Size(const unsigned char size[4]);
	void MakeV2Size(DWORD dwSize,unsigned char size[4]);
	TEString GetId3String(const char szId[]);
	void SetId3String(const char szId[],LPCTSTR szString,LPCTSTR szDescription = NULL);
	size_t GetTotalFrameSize();
	void _SetStringEncode(int encode);
	void v23IDtov22ID(char *v23ID,char *v22ID);
//	void UTF16toUTF16BE(WCHAR *str,int len);
	TEString ReadEncodedTextString(unsigned char encoding, unsigned char *data, size_t dataize, size_t *pdwReadSize);

	void Release();
	int	ID3V2_PADDING_SIZE;
	BOOL m_bEnable;					//ID3v2ꍇFALSE
	int	m_encode;					// GR[h^Cv (0=ISO-8859-1/1=UTF-16/2=UTF-16BE/3=UTF-8)
//	BOOL m_bUnicodeEncode;			//R[hGR[hUnicodegp
	BOOL m_bUnSynchronization;		//񓯊
	ID3HEAD m_head;
	WORD m_wVer;
	std::multimap<DWORD,CId3Frame> m_frames;
	TEString m_strDefaultEnc;		//TENC̃ftHgl
//	WORD m_wDefaultId3TagVersion;	// ID3V2̏l(VK쐬ɂ̃o[WƂȂ)

	static const char *numeric_tags[];
};

#endif // !defined(AFX_ID3TAGV2_H__92584511_76E1_4EE6_90A7_E196C9C0EF88__INCLUDED_)
