// Id3tagv2.cpp: CId3tagv2 NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
//#include "mp3infp_res/resource.h"		// C V{
#include "GlobalCommand.h"
//#include "ClassID.h"
#include "../include/Id3tagv1.h"
#include "../include/Id3tagv2.h"
#include "TfxExtr.h"
#include <assert.h>

//static const unsigned char SCMPX_GENRE_NULL = 247;
//static const unsigned char WINAMP_GENRE_NULL = 255;
const int CId3tagv2::ID3V2CHARENCODE_ISO_8859_1	= 0;
const int CId3tagv2::ID3V2CHARENCODE_UTF_16		= 1;
const int CId3tagv2::ID3V2CHARENCODE_UTF_16BE	= 2;
const int CId3tagv2::ID3V2CHARENCODE_UTF_8		= 3;

const char *CId3tagv2::numeric_tags[] = {
	"TBPM", "TDAT", "TDLY", "TIME", "TLEN", "TPOS", "TRCK", "TSIZ", "TYER",
	"TDEN", "TDOR", "TDRC", "TDRL", "TDTG",
	NULL
};

// 2004-09-24 UTF-16̓gGfBAŏ
//#define UTF16_BIGENDIAN

using	namespace	std;

std::string	GIdToText(DWORD dwId) noexcept
{
	CHAR	sz[sizeof(DWORD) + 1];
	memcpy(sz, &dwId, sizeof(DWORD));
	sz[sizeof(DWORD)]	= '\0';
	return	std::string(sz);
}

bool	GIsIgnoreFrame(CId3Frame* p) noexcept
{
	return	p->GetSize() < 2;
}

size_t CId3Frame::LoadFrame2_4(unsigned char *pData,size_t dwSize)
{
	Release();
	if(dwSize < 10)
	{
		return 0;	//t[wb_Ȃꍇ͏I
	}
	DWORD dwId;
	memcpy(&dwId,pData,sizeof(dwId));
	if(!dwId || dwId == (DWORD)-1)
	{
		return 0;	//ȃt[ID
	}
	DWORD size = (((DWORD )(pData[4]&0x7f)<<21) | ((DWORD )(pData[5]&0x7f)<<14) | ((DWORD )(pData[6]&0x7f)<<7) | ((DWORD )(pData[7]&0x7f)));
	if(size == 0 || size == (DWORD)-1 || (size+10) > dwSize)
	{
		return 0;	//wb_TCY̓f[^𒴉߂Ă
	}
	m_data = (unsigned char *)malloc(size);
	if(!m_data)
	{
		return 0;	//mۂłȂ
	}
	m_dwSize = size;
	m_dwId = dwId;
	m_wFlags = ExtractI2(&pData[8]);
	memcpy(m_data,&pData[10],size);
	return (size + 10);
}

size_t CId3Frame::LoadFrame2_3(unsigned char *pData,size_t dwSize)
{
	Release();
	if(dwSize < 10)
	{
		return 0;	//t[wb_Ȃꍇ͏I
	}
	DWORD dwId;
	memcpy(&dwId,pData,sizeof(dwId));
	if(!dwId || dwId == (DWORD)-1)
	{
		return 0;	//ȃt[ID
	}
	DWORD size = (((DWORD )pData[4]<<24) | ((DWORD )pData[5]<<16) | ((DWORD )pData[6]<<8) | (DWORD )pData[7]);
	if(size == 0 || size == (DWORD)-1 || (size+10) > dwSize)
	{
		return 0;	//wb_TCY̓f[^𒴉߂Ă
	}
	m_data = (unsigned char *)malloc(size);
	if(!m_data)
	{
		return 0;	//mۂłȂ
	}
//		memcpy(&m_dwId,pData,sizeof(m_dwId));
	m_dwSize = size;
	m_dwId = dwId;
	m_wFlags = ExtractI2(&pData[8]);
	memcpy(m_data,&pData[10],size);
	return (size + 10);
}

size_t CId3Frame::LoadFrame2_2(unsigned char *pData,size_t dwSize)
{
	Release();
	if(dwSize < 6)
	{
		return 0;	//t[wb_Ȃꍇ͏I
	}
	DWORD size = (((DWORD )pData[3]<<16) | ((DWORD )pData[4]<<8) | (DWORD )pData[5]);
	if(size == 0 || size == (DWORD)-1 || (size+6) > dwSize)
	{
		return 0;	//wb_TCY̓f[^𒴉߂Ă
	}
	BYTE id[3+1];
	memcpy(&id,pData,sizeof(id));
	id[3] = '\0';
//	TRACE(_T("id=%s (size=%d)\n"),id,size);
	//v2.2v2.3փt[IDϊ
	int i;
	for (i = 0; id3_v23v22table[i].v23 != NULL; i++) {
		if (memcmp(id, id3_v23v22table[i].v22, sizeof(id)) == 0) {
			memcpy(&m_dwId, id3_v23v22table[i].v23, sizeof(m_dwId));
			break;
		}
	}
	if (id3_v23v22table[i].v23 == NULL) {
		memcpy(&m_dwId, "XXXX", sizeof(m_dwId));	// s
	}

	m_data = (unsigned char *)malloc(size);
	if(!m_data)
	{
		return 0;	//mۂłȂ
	}
	m_dwSize = size;
	m_wFlags = 0;	//v2.2
	memcpy(m_data,&pData[6],size);
	return (size + 6);
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CId3tagv2::CId3tagv2() :
	ID3V2_PADDING_SIZE(2048)
{
	m_encode = ID3V2CHARENCODE_ISO_8859_1;
	m_bUnSynchronization = FALSE;
//	m_wDefaultId3TagVersion = 0x0300;
	Release();
}

CId3tagv2::~CId3tagv2()
{
}

void CId3tagv2::Release()
{
	m_bEnable = FALSE;
	memset(&m_head,0,sizeof(m_head));
	memcpy(m_head.id3des,"ID3",3);

	m_wVer = 0x0300;
	m_frames.clear();
}

void CId3tagv2::SetEncDefault(LPCTSTR szDefaultEnc)
{
	m_strDefaultEnc = szDefaultEnc;
}

TEString CId3tagv2::ReadEncodedTextString(unsigned char encoding,
		unsigned char *data, size_t datasize, size_t *pdwReadSize)
{
	size_t	len = 0;
	size_t	readsize = 0;
	size_t	dwDummy;
	if (pdwReadSize == NULL) {
		pdwReadSize = &dwDummy;
	}
	if ((data == NULL) || (datasize <= 0)) {
		*pdwReadSize = readsize;
		return _T("");
	}

	const	size_t	_datasize	= datasize;

	int code;
	unsigned char *start = data;
	switch (encoding) {
	case 0:
		code = DTC_CODE_ANSI;
		break;
	case 1:
		if (_datasize < 2) {
			*pdwReadSize = readsize;
			return _T("");
		}
		readsize += 2;	// BOM
		start += 2;
		if (memcmp(data, "\xff\xfe", 2) == 0) {
			code = DTC_CODE_UTF16LE;
		} else if (memcmp(data, "\xfe\xff", 2) == 0) {
			code = DTC_CODE_UTF16BE;
		} else {
			*pdwReadSize = readsize;
			return _T("");
		}
		break;
	case 2:
		code = DTC_CODE_UTF16BE;
		break;
	case 3:
		code = DTC_CODE_UTF8;
		break;
	}
	if ((encoding == 1) || (encoding == 2)) {
		for (; readsize < _datasize; readsize += 2) {
			if (*(WCHAR*)(data + readsize) == L'\0') {
				break;
			}
		}
		len = readsize - (start - data);
		if ((readsize + 2 <= _datasize) && (*(WCHAR*)(data + readsize) == L'\0')) {
			readsize += 2;
		}
	} else {
		for (; readsize < _datasize; readsize++) {
			if (data[readsize] == '\0') {
				break;
			}
		}
		len = readsize;
		if ((readsize + 1 <= _datasize) && (data[readsize] == '\0')) {
			readsize++;
		}
	}
	*pdwReadSize = readsize;
	return DataToCString((const char *)start, len, code);
}

TEString CId3tagv2::GetId3String(const char szId[])
{
	pair< multimap< DWORD , CId3Frame >::iterator, multimap< DWORD , CId3Frame >::iterator > pp;
	multimap<DWORD,CId3Frame>::iterator p;
	DWORD dwId;
	size_t dwReadSize;
	unsigned char *data;
//	DWORD i;
	switch(szId[0]){
	case 'T':	//eLXgt[
		memcpy(&dwId,szId,sizeof(dwId));
		pp= m_frames.equal_range(dwId);
		if(pp.first == pp.second)
		{
			break;
		}
		p = pp.first;
		if(p->second.GetSize() == 0)
		{
			break;
		}
		data = p->second.GetData();
		return ReadEncodedTextString(data[0], &data[1], p->second.GetSize()-1, NULL);
	case 'W':	//URLNt[x
		if(strcmp(szId,"WXXX") != 0)
		{
			break;
		}
		memcpy(&dwId,szId,sizeof(dwId));
		pp= m_frames.equal_range(dwId);
		if(pp.first == pp.second)
		{
			break;
		}
		p = pp.first;
		if(p->second.GetSize() == 0)
		{
			break;
		}
		data = p->second.GetData();

		//ǂݔ΂
		ReadEncodedTextString(data[0], &data[1], p->second.GetSize()-1, &dwReadSize);
		//URL{
		//Ki͏ ISO-8859-1i݊̂߁ABOM΂Dj
		if ((p->second.GetSize()-1-dwReadSize >= 2)
				&& (data[0] == 1)
				&& ((memcmp(&data[1+dwReadSize], "\xff\xfe", 2) == 0)
					|| (memcmp(&data[1+dwReadSize], "\xfe\xff", 2) == 0))) {
			return ReadEncodedTextString(1, &data[1+dwReadSize], p->second.GetSize()-1-dwReadSize, NULL);
		}
		return ReadEncodedTextString(0, &data[1+dwReadSize], p->second.GetSize()-1-dwReadSize, NULL);
	case 'C':
		if(strcmp(szId,"COMM") != 0)
		{
			break;
		}
		memcpy(&dwId,szId,sizeof(dwId));
		for (pp = m_frames.equal_range(dwId); pp.first != pp.second; ++pp.first)
		{
			p = pp.first;
			if(p->second.GetSize() == 0)
			{
				continue;
			}
			data = p->second.GetData();

			// ꕶǂݔ΂A擾
			TEString desc = ReadEncodedTextString(data[0], &data[4], p->second.GetSize()-4, &dwReadSize);
			if(desc.substr(0, 4) == _T("iTun"))
			{
				// iTunesŗL̃Rg̓XLbv (iTunNORM, iTunSMPB, etc.)
				continue;
			}
			//{
			return ReadEncodedTextString(data[0], &data[4+dwReadSize], p->second.GetSize()-4-dwReadSize, NULL);
		}
		break;
	}
	return _T("");
}

void CId3tagv2::SetId3String(const char szId[],LPCTSTR szString,LPCTSTR szDescription)
{
	pair< multimap< DWORD, CId3Frame >::iterator, multimap< DWORD, CId3Frame >::iterator > pp;
	multimap<DWORD,CId3Frame>::iterator p;
	CId3Frame *pFrame;
	DWORD dwId;
	memcpy(&dwId,szId,sizeof(dwId));

	//Loadt@CɃt[Ȃꍇ
	if((lstrlen(szString) == 0) && (strcmp(szId,"COMM") != 0))
	{
		m_frames.erase(dwId);	//()
		return;
	}

	unsigned char *data;
	int size = 0;
	int encode, i;
	switch(szId[0]){
	case 'T':	//eLXgt[
		encode = m_encode;
		//ISO-8859-1
		for (i = 0; numeric_tags[i] != NULL; i++) {
			if (strcmp(szId, numeric_tags[i]) == 0) {
				encode = ID3V2CHARENCODE_ISO_8859_1;
				break;
			}
		}
		switch(encode){
		case ID3V2CHARENCODE_ISO_8859_1:
		default:	// ISO-8859-1
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_ANSI) + 1;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 0;	//encoding
			TstrToData(szString, -1, (char *)&data[1], size-1, DTC_CODE_ANSI);
			break;
		case ID3V2CHARENCODE_UTF_16:	// UTF-16
#ifndef UTF16_BIGENDIAN
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16LE) + 3;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 1;	//encoding
			data[1] = 0xff;	//BOM
			data[2] = 0xfe;
			TstrToData(szString, -1, (char *)&data[3], size-3, DTC_CODE_UTF16LE);
			break;
#else
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16BE) + 3;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 1;	//encoding
			data[1] = 0xfe;	//BOM
			data[2] = 0xff;
			TstrToData(szString, -1, (char *)&data[3], size-3, DTC_CODE_UTF16BE);
			break;
#endif
		case ID3V2CHARENCODE_UTF_16BE:	// UTF-16BE
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16BE) + 1;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 0x02;	//encoding
			TstrToData(szString, -1, (char *)&data[1], size-1, DTC_CODE_UTF16BE);
			break;
		case ID3V2CHARENCODE_UTF_8:	// UTF-8
			{
				size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF8) + 1;
				data = (unsigned char *)malloc(size);
				if(!data)
				{
					return;
				}
				data[0] = 3;	//encoding
				TstrToData(szString, -1, (char *)&data[1], size-1, DTC_CODE_UTF8);
				break;
			}
		}
//		p = m_frames.find(dwId);
		pp= m_frames.equal_range(dwId);
		if((pp.first == pp.second) || !(pp.first->second.GetSize()))
		{
			//Loadt@CɃt[Ȃꍇ
			CId3Frame frame;
			frame.SetId(dwId);
			frame.SetFlags(0);
			frame.SetData(data,size);
			m_frames.insert(pair<DWORD,CId3Frame>(frame.GetId(),frame));
		}
		else
		{
			p = pp.first;
			pFrame = &p->second;
			pFrame->SetData(data,size);
		}
		free(data);
		break;
	case 'W':	//URLNt[x
		if(strcmp(szId,"WXXX") != 0)
		{
			break;
		}
		switch(m_encode){
		case ID3V2CHARENCODE_ISO_8859_1:
		default:	// ISO-8859-1
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_ANSI) + 2;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 0;	//encoding
			data[1] = 0;	//(ȗ)
			TstrToData(szString, -1, (char *)&data[2], size-2, DTC_CODE_ANSI);	//URL{́iISO-8859-1j
			break;
		case ID3V2CHARENCODE_UTF_16:	// UTF-16
#ifndef UTF16_BIGENDIAN
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16LE) + 5;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 1;	//encoding
			data[1] = 0xff;	//BOM
			data[2] = 0xfe;
			data[3] = 0;	//(ȗ)
			data[4] = 0;
			TstrToData(szString, -1, (char *)&data[5], size-5, DTC_CODE_ANSI);	//URL{́iISO-8859-1j
			break;
#else	// rbNGfBA
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16BE) + 5;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 1;	//encoding
			data[1] = 0xfe;	//BOM
			data[2] = 0xff;
			data[3] = 0;	//(ȗ)
			data[4] = 0;
			TstrToData(szString, -1, (char *)&data[5], size-5, DTC_CODE_ANSI);	//URL{́iISO-8859-1j
			break;
#endif
		case ID3V2CHARENCODE_UTF_16BE:	// UTF-16BE
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16BE) + 3;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 2;	//encoding
			data[1] = 0;	//(ȗ)
			data[2] = 0;
			TstrToData(szString, -1, (char *)&data[3], size-3, DTC_CODE_ANSI);	//URL{́iISO-8859-1j
			break;
		case ID3V2CHARENCODE_UTF_8:	// UTF-8
			{
				size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF8) + 2;
				data = (unsigned char *)malloc(size);
				if(!data)
				{
					return;
				}
				data[0] = 3;	//encoding
				data[1] = 0;	//(ȗ)
				TstrToData(szString, -1, (char *)&data[2], size-2, DTC_CODE_ANSI);	//URL{́iISO-8859-1j
				break;
			}
		}
		pp= m_frames.equal_range(dwId);
		if((pp.first == pp.second) || !(pp.first->second.GetSize()))
		{
			//Loadt@CɃt[Ȃꍇ
			CId3Frame frame;
			frame.SetId(dwId);
			frame.SetFlags(0);
			frame.SetData(data,size);
			m_frames.insert(pair<DWORD,CId3Frame>(frame.GetId(),frame));
		}
		else
		{
			p = pp.first;
			pFrame = &p->second;
			pFrame->SetData(data,size);
		}
		free(data);
		break;
	case 'C':
		if(strcmp(szId,"COMM") != 0)
		{
			break;
		}
		// Rgt[
		for (pp = m_frames.equal_range(dwId); pp.first != pp.second; ++pp.first)
		{
			p = pp.first;
			if(p->second.GetSize() == 0)
			{
				continue;
			}
			unsigned char *data = p->second.GetData();

			// ꕶǂݔ΂A擾
			size_t dwReadSize;
			TEString desc = ReadEncodedTextString(data[0], &data[4], p->second.GetSize()-4, &dwReadSize);
			if(desc.substr(0, 4) == _T("iTun"))
			{
				// iTunesŗL̃Rg̓XLbv (iTunNORM, iTunSMPB, etc.)
				continue;
			}

			// Ώۂ̃Rgt[𔭌

			if(lstrlen(szString) == 0)
			{
				m_frames.erase(p);	//
				return;
			}
			break;
		}
		switch(m_encode){
		case ID3V2CHARENCODE_ISO_8859_1:
		default:	// ISO-8859-1
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_ANSI) + 5;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 0;	//encoding
			data[1] = 'e';	//Language
			data[2] = 'n';
			data[3] = 'g';
			data[4] = 0;	//(ȗ)
			TstrToData(szString, -1, (char *)&data[5], size-5, DTC_CODE_ANSI);
			break;
		case ID3V2CHARENCODE_UTF_16:	// UTF-16
#ifndef UTF16_BIGENDIAN
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16LE) + 10;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 1;	//encoding
			data[1] = 'e';	//Language
			data[2] = 'n';
			data[3] = 'g';
			data[4] = 0xff;	//BOM
			data[5] = 0xfe;
			data[6] = 0;	//(ȗ)
			data[7] = 0;
			data[8] = 0xff;	//BOM
			data[9] = 0xfe;
			TstrToData(szString, -1, (char *)&data[10], size-10, DTC_CODE_UTF16LE);
			break;
#else	// rbOGfBA
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16BE) + 10;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 1;	//encoding
			data[1] = 'e';	//Language
			data[2] = 'n';
			data[3] = 'g';
			data[4] = 0xfe;	//BOM
			data[5] = 0xff;
			data[6] = 0;	//(ȗ)
			data[7] = 0;
			data[8] = 0xfe;	//BOM
			data[9] = 0xff;
			TstrToData(szString, -1, (char *)&data[10], size-10, DTC_CODE_UTF16BE);
			break;
#endif
		case ID3V2CHARENCODE_UTF_16BE:	// UTF-16BE
			size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF16BE) + 6;
			data = (unsigned char *)malloc(size);
			if(!data)
			{
				return;
			}
			data[0] = 2;	//encoding
			data[1] = 'e';	//Language
			data[2] = 'n';
			data[3] = 'g';
			data[4] = 0;	//(ȗ)
			data[5] = 0;	//(ȗ)
			TstrToData(szString, -1, (char *)&data[6], size-6, DTC_CODE_UTF16BE);
			break;
		case ID3V2CHARENCODE_UTF_8:	// UTF-8
			{
				size = TstrToData(szString, -1, NULL, 0, DTC_CODE_UTF8) + 5;
				data = (unsigned char *)malloc(size);
				if(!data)
				{
					return;
				}
				data[0] = 3;	//encoding
				data[1] = 'e';	//Language
				data[2] = 'n';
				data[3] = 'g';
				data[4] = 0;	//(ȗ)
				TstrToData(szString, -1, (char *)&data[5], size-5, DTC_CODE_UTF8);
				break;
			}
		}
	//	pp= m_frames.equal_range(dwId);
		if((pp.first == pp.second) || !(pp.first->second.GetSize()))
		{
			CId3Frame frame;
			frame.SetId(dwId);
			frame.SetFlags(0);
			frame.SetData(data,size);
			m_frames.insert(pair<DWORD,CId3Frame>(frame.GetId(),frame));
		}
		else
		{
			p = pp.first;
			pFrame = &p->second;
			pFrame->SetData(data,size);
		}
		free(data);
		break;
	}
	return;
}

size_t CId3tagv2::GetTotalFrameSize()
{
	size_t	sztSize = 0;
	auto	p = m_frames.begin();
	while(p != m_frames.end())
	{
		CId3Frame *pFrame = &p->second;
		if (!GIsIgnoreFrame(pFrame)) {
			if (m_wVer == 0x0200)
			{
				sztSize += pFrame->GetSize() + 6;
			}
			else
			{
				sztSize += pFrame->GetSize() + 10;
			}
		}
		p++;
	}
	return sztSize;
}

// SẴt[̕GR[hw肷
void CId3tagv2::_SetStringEncode(int encode)
{
	multimap<DWORD, CId3Frame>::iterator p;

	p = m_frames.begin();
	while(p != m_frames.end())
	{
		CId3Frame *pFrame = &p->second;
		unsigned char *data = pFrame->GetData();

		switch(encode)
		{
		default:
		case ID3V2CHARENCODE_ISO_8859_1:
			data[0] = 0;
			break;
		case ID3V2CHARENCODE_UTF_16:
			data[0] = 1;
			break;
		case ID3V2CHARENCODE_UTF_16BE:
			data[0] = 2;
			break;
		case ID3V2CHARENCODE_UTF_8:
			data[0] = 3;
			break;
		}

		p++;
	}
}

id3_v23v22table_t id3_v23v22table[] = {
	{"AENC", "CRA"},
	{"APIC", "PIC"},
	{"COMM", "COM"},
	{"EQUA", "EQU"},
	{"ETCO", "ETC"},
	{"GEOB", "GEO"},
	{"IPLS", "IPL"},
	{"MCDI", "MCI"},
	{"MLLT", "MLL"},
	{"PCNT", "CNT"},
	{"POPM", "POP"},
	{"RBUF", "BUF"},
	{"RVAD", "RVA"},
	{"RVRB", "REV"},
	{"SYLT", "SLT"},
	{"SYTC", "STC"},
	{"TALB", "TAL"},
	{"TBPM", "TBP"},
	{"TCOM", "TCM"},
	{"TCON", "TCO"},
	{"TCOP", "TCR"},
	{"TDAT", "TDA"},
	{"TDLY", "TDY"},
	{"TENC", "TEN"},
	{"TFLT", "TFT"},
	{"TIME", "TIM"},
	{"TIT1", "TT1"},
	{"TIT2", "TT2"},
	{"TIT3", "TT3"},
	{"TKEY", "TKE"},
	{"TLAN", "TLA"},
	{"TLEN", "TLE"},
	{"TMED", "TMT"},
	{"TOAL", "TOT"},
	{"TOFN", "TOF"},
	{"TOLY", "TOL"},
	{"TOPE", "TOA"},
	{"TORY", "TOR"},
	{"TPE1", "TP1"},
	{"TPE2", "TP2"},
	{"TPE3", "TP3"},
	{"TPE4", "TP4"},
	{"TPOS", "TPA"},
	{"TPUB", "TPB"},
	{"TRCK", "TRK"},
	{"TRDA", "TRD"},
	{"TSIZ", "TSI"},
	{"TSRC", "TRC"},
	{"TSSE", "TSS"},
	{"TYER", "TYE"},
	{"TXXX", "TXX"},
	{"UFID", "UFI"},
	{"USLT", "ULT"},
	{"WCOM", "WCM"},
	{"WCOP", "WCP"},
	{"WOAF", "WAF"},
	{"WOAR", "WAR"},
	{"WOAS", "WAS"},
	{"WPUB", "WPB"},
	{"WXXX", "WXX"},
	{NULL, NULL}
};

void CId3tagv2::v23IDtov22ID(char *v23ID,char *v22ID)
{
	//v2.3v2.2փt[IDϊ
	int i;
	for (i = 0; id3_v23v22table[i].v23 != NULL; i++) {
		if (memcmp(v23ID, id3_v23v22table[i].v23, 4) == 0) {
			memcpy(v22ID, id3_v23v22table[i].v22, 3);
			break;
		}
	}
	if (id3_v23v22table[i].v23 == NULL) {
		memcpy(v22ID, "XXX", 3);	// s
	}
}

#if 0
// UNICODEBE/LEϊ(len=)
void CId3tagv2::UTF16toUTF16BE(WCHAR *str,int len)
{
	for(int i=0; i<len; i++)
	{
		str[i] = (str[i] << 8) | (str[i] >> 8);
	}
}
#endif

TEString CId3tagv2::GetTitle()
{
	//^Cg
	return GetId3String("TIT2");
}

void CId3tagv2::SetTitle(LPCTSTR title)
{
	//^Cg
	SetId3String("TIT2",title);
}

TEString CId3tagv2::GetTrackNo()
{
	//gbNԍ
	return GetId3String("TRCK");
}

void CId3tagv2::SetTrackNo(LPCTSTR szTrackNo)
{
	//gbNԍ
	SetId3String("TRCK",szTrackNo);
}

TEString CId3tagv2::GetArtist()
{
	//A[eBXg
	return GetId3String("TPE1");
}

void CId3tagv2::SetArtist(LPCTSTR artist)
{
	//A[eBXg
	SetId3String("TPE1",artist);
}

TEString CId3tagv2::GetAlbumArtist()
{
	//AoA[eBXg
	return GetId3String("TPE2");
}

void CId3tagv2::SetAlbumArtist(LPCTSTR albumartist)
{
	//AoA[eBXg
	SetId3String("TPE2",albumartist);
}

TEString CId3tagv2::GetAlbum()
{
	//Ao
	return GetId3String("TALB");
}

void CId3tagv2::SetAlbum(LPCTSTR album)
{
	//Ao
	SetId3String("TALB",album);
}

TEString CId3tagv2::GetYear()
{
	//
	if(m_wVer < 0x0400)
	{
		return GetId3String("TYER");
	}
	else
	{
		return GetId3String("TDRC");
	}
}

void CId3tagv2::SetYear(LPCTSTR year)
{
	//
	if(m_wVer < 0x0400)
	{
		SetId3String("TDRC",_T(""));
		SetId3String("TYER",year);
	}
	else
	{
		SetId3String("TDRC",year);
		SetId3String("TYER",_T(""));
	}
}

TEString CId3tagv2::GetGenre()
{
	//W
	TEString strGenre = GetId3String("TCON");
	int genre = -1;
//	unsigned char *data = (unsigned char *)(LPCSTR )strGenre;
	//ŏ()ǂݔ΂	Fix 2001-05-20
	while(1)
	{
		if(strGenre.size() &&
			!IS_LEAD_TBYTE(strGenre[0]) &&
			(strGenre[0] == '(') )	//ɃJbRo
		{
			if((strGenre.size() > 1) &&
				!IS_LEAD_TBYTE(strGenre[1]) &&
				(strGenre[1] == '(') )
			{
				strGenre	= strGenre.substr(1);	//擪'('폜
				break;
			}
			const	size_t	index = strGenre.find(')');
			if(index != strGenre.npos)
			{
				if (genre == -1) {
					TEString strGenreNum = strGenre.substr(1, index);
					genre = _ttoi(strGenreNum.c_str());
				}
				strGenre	= strGenre.substr(index+1);	//)'ȑO폜
				continue;	//Fix 2001-10-24
			}
		}
		break;
	}
	//Wԍ݂̂Ŏw肳Ăꍇ́Aɕϊ
	if ((genre >= 0) && (strGenre == _T(""))) {
		CId3tagv1 id3tagv1(FALSE);
		id3tagv1.SetGenre(genre);
		strGenre = id3tagv1.GetGenre();
	}
	return strGenre;
}

void CId3tagv2::SetGenre(LPCTSTR szGenre)
{
	//W
	TEString strGenre;
/*	CId3tagv1 id3tagv1(m_bScmpxGenre);
	long genre = id3tagv1.GenreString2Num(szGenre);
	if((genre != -1) &&
		!((m_bScmpxGenre && (SCMPX_GENRE_NULL == genre)) || (!m_bScmpxGenre && (WINAMP_GENRE_NULL == genre)))
		)
	{
		strGenre.Format(_T("(%d)"),genre);
	}
	2003-01-25 iTunesWR[hւ̎QƂ𐳂ǂ߂Ȃ߁AWR[hȂ悤ɏC
*/
	// 2004-05-16 "("Ŏn܂ꍇ͐擪"("ǉ
	if(lstrlen(szGenre) &&
		!IS_LEAD_TBYTE(szGenre[0]) &&
		(szGenre[0] == '(') )	//ɃJbRo
	{
		strGenre += _T("(");
	}
	strGenre += szGenre;

	SetId3String("TCON",strGenre.c_str());
}

TEString CId3tagv2::GetComment()
{
	//Rg
	return GetId3String("COMM");
}

void CId3tagv2::SetComment(LPCTSTR comment)
{
	//Rg
	SetId3String("COMM",comment);
}

TEString CId3tagv2::GetComposer()
{
	//
	return GetId3String("TCOM");
}

void CId3tagv2::SetComposer(LPCTSTR composer)
{
	//
	SetId3String("TCOM",composer);
}

TEString CId3tagv2::GetOrigArtist()
{
	//Orig.A[eBXg
	return GetId3String("TOPE");
}

void CId3tagv2::SetOrigArtist(LPCTSTR origArtist)
{
	//Orig.A[eBXg
	SetId3String("TOPE",origArtist);
}

TEString CId3tagv2::GetCopyright()
{
	//쌠
	return GetId3String("TCOP");
}

void CId3tagv2::SetCopyright(LPCTSTR copyright)
{
	//쌠
	SetId3String("TCOP",copyright);
}

TEString CId3tagv2::GetUrl()
{
	//URL
	return GetId3String("WXXX");
}

void CId3tagv2::SetUrl(LPCTSTR url)
{
	//URL
	SetId3String("WXXX",url);
}

TEString CId3tagv2::GetEncoder()
{
	//GR[_[
	return GetId3String("TSSE");
}

void CId3tagv2::SetEncoder(LPCTSTR encoder)
{
	//GR[_[
	SetId3String("TSSE",encoder);
}

TEString CId3tagv2::GetEncodest()
{
	//GR[hl܂͑gD
	return GetId3String("TENC");
}

void CId3tagv2::SetEncodest(LPCTSTR encoder)
{
	//GR[hl܂͑gD
	SetId3String("TENC",encoder);
}

size_t CId3tagv2::DecodeUnSynchronization(unsigned char *data,size_t dwSize)
{
	size_t dwDecodeSize = 0;
	unsigned char *writePtr = data;
	BOOL bHitFF = FALSE;

	for(size_t i=0; i<dwSize; i++)
	{
		if(data[i] == 0xff)
		{
			bHitFF = TRUE;
		}
		else
		{
			if(bHitFF && (data[i] == 0x00))
			{
				bHitFF = FALSE;
				continue;
			}
			bHitFF = FALSE;
		}
		writePtr[dwDecodeSize] = data[i];
		dwDecodeSize++;
	}
	return dwDecodeSize;
}

size_t CId3tagv2::EncodeUnSynchronization(unsigned char *srcData,size_t dwSize,unsigned char *dstData)
{
	size_t dwDecodeSize = 0;
	unsigned char *writePtr = dstData;
	BOOL bHitFF = FALSE;

	for(size_t i=0; i<dwSize; i++)
	{
		if(bHitFF && (((srcData[i]&0xe0) == 0xe0) || (srcData[i] == 0x00)) )
		{
			writePtr[dwDecodeSize] = 0x00;
			dwDecodeSize++;
		}
		if(srcData[i] == 0xff)
		{
			bHitFF = TRUE;
		}
		else
		{
			bHitFF = FALSE;
		}
		writePtr[dwDecodeSize] = srcData[i];
		dwDecodeSize++;
	}
	return dwDecodeSize;
}

DWORD CId3tagv2::ExtractV2Size(const unsigned char size[4])
{
	return (((DWORD )(size[0]&0x7f)<<21) | ((DWORD )(size[1]&0x7f)<<14) | ((DWORD )(size[2]&0x7f)<<7) | (DWORD )(size[3]&0x7f));
}

void CId3tagv2::MakeV2Size(DWORD dwSize,unsigned char size[4])
{
	size[3] = dwSize & 0x7f;
	size[2] = (dwSize>>7) & 0x7f;
	size[1] = (dwSize>>14) & 0x7f;
	size[0] = (dwSize>>21) & 0x7f;
}

DWORD CId3tagv2::Load(LPCTSTR szFileName, unsigned __int64 ofst)
{
	DWORD	dwWin32errorCode = ERROR_SUCCESS;
	Release();
	HANDLE hFile = TECreateFile(
				szFileName,
				GENERIC_READ,
				FILE_SHARE_READ,
				NULL,
				OPEN_EXISTING,	//t@CI[v܂Bwt@C݂ĂȂꍇA֐͎s܂B
				FILE_ATTRIBUTE_NORMAL,
				NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		dwWin32errorCode = GetLastError();
		return dwWin32errorCode;
	}

	::SetFilePointerEx(hFile, McT_UINT64ToLARGE_INT(ofst), NULL, FILE_BEGIN);

	//t@CI[v
	ID3HEAD head;
	memcpy(&head,&m_head, sizeof(m_head));
	//ID3V2wb_ǂݍ
	DWORD dwRet;
	if(!ReadFile(hFile,&head,sizeof(head),&dwRet,NULL) || (dwRet != sizeof(head)))
	{
		CloseHandle(hFile);
		return -1;
	}

	//ID3v2mF
	if(memcmp(head.id3des,"ID3",3) != 0)
	{
		CloseHandle(hFile);
		return -1;
	}

	//o[W
	WORD ver = (head.ver[0]<<8) | head.ver[1];
	if((ver != 0x0200) &&
		(ver != 0x0300) &&
		(ver != 0x0301) &&
		(ver != 0x0400) )
	{
		// ID3v2.4傫o[W̓T|[gȂ
		CloseHandle(hFile);
		return -1;
	}
	m_wVer = ver;
	if(m_wVer == 0x0301)
	{
		m_wVer = 0x0400;
	}

	//Id3tagTCY
	size_t dwId3Size = ExtractV2Size(head.size);

	// fobOpɃwb_܂߂ēǂ݂Ȃ.
	::SetFilePointerEx(hFile, McT_UINT64ToLARGE_INT(ofst), NULL, FILE_BEGIN);

	//St[̓Ǎ
	unsigned char *_buf = (unsigned char *)malloc(dwId3Size + sizeof head);
	if(!_buf)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		return dwWin32errorCode;
	}
	if(!ReadFile(hFile,_buf,(DWORD)dwId3Size + sizeof head,&dwRet,NULL) || (dwRet != dwId3Size + sizeof head))
	{
		free(_buf);
		CloseHandle(hFile);
		return -1;
	}
	unsigned char *buf = _buf + sizeof head;

	//񓯊̉
	if(head.flag & 0x80)
	{
		dwId3Size = DecodeUnSynchronization(buf,dwId3Size);
		m_bUnSynchronization = TRUE;
	}
	else
	{
		m_bUnSynchronization = FALSE;
	}

	size_t dwRemainSize = dwId3Size;
	//gwb_ǂݔ΂(ID3v2.2ɂ݂͑Ȃ)
	if((ver != 0x0200) && (head.flag & 0x40))
	{
		dwRemainSize -= ExtractV2Size(buf) + 4;
	}
	head.flag &= ~0x40;	//

	m_encode = ID3V2CHARENCODE_ISO_8859_1;
	while(dwRemainSize)
	{
		CId3Frame frame;
		size_t dwReadSize;
		unsigned char *pNext	= buf+(dwId3Size-dwRemainSize);
		if(m_wVer < 0x0300)
		{
			dwReadSize = frame.LoadFrame2_2(pNext,dwRemainSize);
		}
		else if(m_wVer < 0x0400)
		{
			dwReadSize = frame.LoadFrame2_3(pNext,dwRemainSize);
		}
		else
		{
			dwReadSize = frame.LoadFrame2_4(pNext,dwRemainSize);
		}
		if(!dwReadSize)
			break;
		unsigned char *data = frame.GetData();
		if(frame.GetSize() && data)
		{
			switch(data[0]){
			case 0:
			default:	// ISO-8859-1
				break;
			case 1:		// UTF-16
				if(data[0] > ID3V2CHARENCODE_ISO_8859_1)
				{
					m_encode = ID3V2CHARENCODE_UTF_16;
				}
				break;
			case 2:		// UTF-16BE
				if(data[0] > ID3V2CHARENCODE_UTF_16)
				{
					m_encode = ID3V2CHARENCODE_UTF_16BE;
				}
				break;
			case 3:		// UTF-8
				if(data[0] > ID3V2CHARENCODE_UTF_16BE)
				{
					m_encode = ID3V2CHARENCODE_UTF_8;
				}
				break;
			}
		}
		m_frames.insert(pair<DWORD,CId3Frame>(frame.GetId(),frame));
		dwRemainSize -= dwReadSize;
	}

	free(_buf);
	CloseHandle(hFile);

//	if(m_wVer < 0x0300)	//v2.2v2.3֕ϊĕۑ
//	{
//		head.ver[0] = 0x03;
//		head.ver[1] = 0x00;
//		m_wVer = 0x0300;
//	}

	memcpy(&m_head,&head, sizeof(m_head));
	m_bEnable = TRUE;

	return dwWin32errorCode;
}

DWORD CId3tagv2::Save(LPCTSTR szFileName)
{
	DWORD	dwWin32errorCode = ERROR_SUCCESS;
	HANDLE	hFile;
	BOOL	bInsPadding = FALSE;
	DWORD	dwWritten = 0;
	TCHAR	szTempPath[MAX_PATH];
	TCHAR	szTempFile[MAX_PATH];
	GetTempPath(_countof(szTempPath), szTempPath);

	if(!m_bEnable)
	{
		return -1;
	}

/*
	// GR[hw$2/$3ĝv2.4ȍ~
	if(m_wVer < 0x0400)
	{
		if(	(m_encode != ID3V2CHARENCODE_ISO_8859_1) &&
			(m_encode != ID3V2CHARENCODE_UTF_16) )
		{
			// ISO-8859-1Ɏݒ
			m_encode = ID3V2CHARENCODE_ISO_8859_1;
		}
	}

	// St[̕GR[hݒ
	_SetStringEncode(m_encode);
*/

	size_t dwTotalFrameSize = GetTotalFrameSize();
	//t[o
	unsigned char *pFrameData = (unsigned char *)malloc(dwTotalFrameSize);
	if(!pFrameData)
	{
		dwWin32errorCode = GetLastError();
		return dwWin32errorCode;
	}
	{
		size_t dwFrameDataPtr = 0;
		multimap<DWORD, CId3Frame>::iterator p;
		p = m_frames.begin();
		while (p != m_frames.end()) {
			CId3Frame *pFrame = &p->second;
			size_t dwSize = pFrame->GetSize();
			DWORD id = pFrame->GetId();
			//TCY0̂Ƃ̓t[܂Ȃ
			if (GIsIgnoreFrame(pFrame)) {
				p++;
				continue;
			}
			WORD flags = pFrame->GetFlags();
			WORD flagsBe = ((flags << 8) | (flags >> 8));
			unsigned char *data = pFrame->GetData();
			if (m_wVer == 0x0200) {
				unsigned char size[3];
				size[2] = dwSize & 0xff;
				size[1] = (dwSize >> 8) & 0xff;
				size[0] = (dwSize >> 16) & 0xff;
				// id3v2.2
				char v22id[3];
				//v2.3v2.2փt[IDϊ
				v23IDtov22ID((char *)&id, v22id);
				memcpy(&pFrameData[dwFrameDataPtr], &v22id, sizeof(v22id));
				dwFrameDataPtr += sizeof(v22id);
				memcpy(&pFrameData[dwFrameDataPtr], size, sizeof(size));
				dwFrameDataPtr += sizeof(size);
				memcpy(&pFrameData[dwFrameDataPtr], data, dwSize);
				dwFrameDataPtr += dwSize;
			}
			else if (m_wVer == 0x0300) {
				unsigned char size[4];
				size[3] = dwSize & 0xff;
				size[2] = (dwSize >> 8) & 0xff;
				size[1] = (dwSize >> 16) & 0xff;
				size[0] = (dwSize >> 24) & 0xff;
				// id3v2.3-
				memcpy(&pFrameData[dwFrameDataPtr], &id, sizeof(id));
				dwFrameDataPtr += sizeof(id);
				memcpy(&pFrameData[dwFrameDataPtr], size, sizeof(size));
				dwFrameDataPtr += sizeof(size);
				memcpy(&pFrameData[dwFrameDataPtr], &flagsBe, sizeof(flagsBe));
				dwFrameDataPtr += sizeof(flagsBe);
				memcpy(&pFrameData[dwFrameDataPtr], data, dwSize);
				dwFrameDataPtr += dwSize;
			}
			else {
				unsigned char size[4];
				MakeV2Size((DWORD)dwSize, size);
				// 
				dwSize &= 0x0fffffff;
				// id3v2.4
				memcpy(&pFrameData[dwFrameDataPtr], &id, sizeof(id));
				dwFrameDataPtr += sizeof(id);
				memcpy(&pFrameData[dwFrameDataPtr], size, sizeof(size));
				dwFrameDataPtr += sizeof(size);
				memcpy(&pFrameData[dwFrameDataPtr], &flagsBe, sizeof(flagsBe));
				dwFrameDataPtr += sizeof(flagsBe);
				memcpy(&pFrameData[dwFrameDataPtr], data, dwSize);
				dwFrameDataPtr += dwSize;
			}
			p++;
		}
		//	ASSERT(dwFrameDataPtr == dwTotalFrameSize);
	}

	//񓯊
	if(m_bUnSynchronization)
	{
		unsigned char *pEncData = (unsigned char *)malloc(dwTotalFrameSize*2);
		size_t dwEncodeSize = EncodeUnSynchronization(pFrameData,dwTotalFrameSize,pEncData);
//		if(dwEncodeSize != dwTotalFrameSize)
//	2004-03-20 vpeBɔ񓯊XCb`߁A񓯊tO͕KĂ邱Ƃɂ
//	(񓯊ONۑłȂlq̓[U݂ĂȓɌ邽)
		{
			//񓯊tOZbg
			m_head.flag |= 0x80;
			dwTotalFrameSize = dwEncodeSize;
		}
		free(pFrameData);
		pFrameData = pEncData;
	}
	else
	{
		//񓯊tO
		m_head.flag &= ~0x80;
	}

	//Id3tagTCY
	size_t	dwId3Size = ExtractV2Size(m_head.size);

	if(dwTotalFrameSize > dwId3Size)
	{
		//
		//	̈悩炠ӂꂽ.
		//	[pfBÖ}]

		//	dwId3Size , ̗̈悪ׂ悤ɂ.
		const size_t dwPaddingSize = dwTotalFrameSize - dwId3Size + ID3V2_PADDING_SIZE;

		//	VTCYɂĂ.
		dwId3Size += dwPaddingSize;

		//==================t@Cɕۑ==================
		hFile = TECreateFile(
					szFileName,
					GENERIC_READ,
					FILE_SHARE_READ,
					NULL,
					OPEN_EXISTING,	//wt@C݂ĂȂꍇA֐͎s܂B
					FILE_ATTRIBUTE_NORMAL,
					NULL);
		if(hFile == INVALID_HANDLE_VALUE)
		{
			dwWin32errorCode = GetLastError();
			free(pFrameData);
			return dwWin32errorCode;
		}

		const DWORD	dwFileSize = GetFileSize(hFile,NULL);
		//obt@̊m
		char *pRawData = (char *)malloc(dwFileSize);
		if(!pRawData)
		{
			dwWin32errorCode = GetLastError();
			CloseHandle(hFile);
			free(pFrameData);
			return dwWin32errorCode;
		}
		//raw data̓ǂݏo
		if(!ReadFile(hFile,pRawData,dwFileSize,&dwWritten,NULL))
		{
			dwWin32errorCode = GetLastError();
			CloseHandle(hFile);
			free(pRawData);
			free(pFrameData);
			return dwWin32errorCode;
		}
		CloseHandle(hFile);

		//==================e|쐬==================
		//e|擾
		if(!GetTempFileName(szTempPath,_T("tms"),0,szTempFile))
		{
			dwWin32errorCode = GetLastError();
			free(pRawData);
			TEDeleteFile(szTempFile);
			free(pFrameData);
			return dwWin32errorCode;
		}
		//t@CI[v(wt@Cłɑ݂ĂꍇÃt@C͏㏑܂B)
		hFile = TECreateFile(szTempFile,GENERIC_WRITE|GENERIC_READ,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(hFile == INVALID_HANDLE_VALUE)
		{
			dwWin32errorCode = GetLastError();
			free(pRawData);
			TEDeleteFile(szTempFile);
			free(pFrameData);
			return dwWin32errorCode;
		}
		//܂Ȃ
		if(SetFilePointer(hFile,0,NULL,FILE_BEGIN) == INVALID_SET_FILE_POINTER)
		{
			dwWin32errorCode = GetLastError();
			CloseHandle(hFile);
			free(pRawData);
			TEDeleteFile(szTempFile);
			free(pFrameData);
			return dwWin32errorCode;
		}
		//pfBÖXLbv
		if(SetFilePointer(hFile,(DWORD)dwPaddingSize,NULL,FILE_BEGIN) == INVALID_SET_FILE_POINTER)
		{
			dwWin32errorCode = GetLastError();
			CloseHandle(hFile);
			free(pRawData);
			TEDeleteFile(szTempFile);
			free(pFrameData);
			return dwWin32errorCode;
		}
		//\ߓǂݍ񂾌t@Co.
		if(WriteFile(hFile,pRawData,dwFileSize,&dwWritten,NULL) == 0)
		{
			dwWin32errorCode = GetLastError();
			CloseHandle(hFile);
			free(pRawData);
			TEDeleteFile(szTempFile);
			free(pFrameData);
			return dwWin32errorCode;
		}

		free(pRawData);

		bInsPadding = TRUE;
	}
	else
	{
		//t@CI[v
		hFile = TECreateFile(
					szFileName,
					GENERIC_READ|GENERIC_WRITE,
					FILE_SHARE_READ,
					NULL,
					OPEN_EXISTING,	//t@CI[v܂Bwt@C݂ĂȂꍇA֐͎s܂B
					FILE_ATTRIBUTE_NORMAL,
					NULL);
		if(hFile == INVALID_HANDLE_VALUE)
		{
			dwWin32errorCode = GetLastError();
			free(pFrameData);
			return dwWin32errorCode;
		}
	}

	//ID3v2wb_
	if(SetFilePointer(hFile,0,NULL,FILE_BEGIN) == INVALID_SET_FILE_POINTER)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		TEDeleteFile(szTempFile);
		free(pFrameData);
		return dwWin32errorCode;
	}
	ID3HEAD head;
	m_head.ver[0] = (m_wVer & 0xff00) >> 8;
	m_head.ver[1] = (m_wVer & 0x00ff);
	memcpy(&head,&m_head,sizeof(m_head));
	MakeV2Size((DWORD)dwId3Size,head.size);
	// 
	dwId3Size &= 0x0fffffff;
	if(WriteFile(hFile,&head,sizeof(head),&dwWritten,NULL) == 0)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		TEDeleteFile(szTempFile);
		free(pFrameData);
		return dwWin32errorCode;
	}
	memcpy(&m_head,&head,sizeof(head));

	//t[t@Cɏo
	if(SetFilePointer(hFile,10,NULL,FILE_BEGIN) == INVALID_SET_FILE_POINTER)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		TEDeleteFile(szTempFile);
		free(pFrameData);
		return dwWin32errorCode;
	}
	if(!WriteFile(hFile,pFrameData,(DWORD)dwTotalFrameSize,&dwWritten,NULL))
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		if(bInsPadding)
		{
			TEDeleteFile(szTempFile);
		}
		free(pFrameData);
		return dwWin32errorCode;
	}
	free(pFrameData);

	//pfBÖ0ŃpfBO
	const auto	nPadSize	= (int)(dwId3Size - dwTotalFrameSize);
	for (int i = 0; i < nPadSize; ++i)
	{
		DWORD dwRet;
		unsigned char pad = 0x00;
		if(!WriteFile(hFile,&pad,1,&dwRet,NULL))
		{
			dwWin32errorCode = GetLastError();
			CloseHandle(hFile);
			if(bInsPadding)
			{
				TEDeleteFile(szTempFile);
			}
			return dwWin32errorCode;
		}
	}

	CloseHandle(hFile);

	if(bInsPadding)
	{
		//IWit@Cޔ(l[)
		TCHAR szPreFile[MAX_PATH];
		if(!GetTempFileName(szTempPath,_T("tms"),0,szPreFile))
		{
			dwWin32errorCode = GetLastError();
			TEDeleteFile(szTempFile);
			return dwWin32errorCode;
		}
		TEDeleteFile(szPreFile);//蔲(^^;
		if(!TEMoveFile(szFileName,szPreFile))
		{
			dwWin32errorCode = GetLastError();
			TEDeleteFile(szTempFile);
			return dwWin32errorCode;
		}

		//il[
		if(!TEMoveFile(szTempFile,szFileName))
		{
			dwWin32errorCode = GetLastError();
			TEMoveFile(szPreFile,szFileName);
			TEDeleteFile(szTempFile);
			return dwWin32errorCode;
		}

		//IWi폜
		TEDeleteFile(szPreFile);
	}

	return dwWin32errorCode;
}

DWORD CId3tagv2::DelTag(LPCTSTR szFileName)
{
	DWORD	dwWin32errorCode = ERROR_SUCCESS;
	DWORD	dwWritten = 0;
	TCHAR	szTempPath[MAX_PATH];
	TCHAR	szTempFile[MAX_PATH];
	GetTempPath(_countof(szTempPath), szTempPath);

	if(!m_bEnable)
	{
		return -1;
	}

	//==================t@Cɕۑ==================
	HANDLE hFile = TECreateFile(
							szFileName,
							GENERIC_READ,
							FILE_SHARE_READ,
							NULL,
							OPEN_EXISTING,	//wt@C݂ĂȂꍇA֐͎s܂B
							FILE_ATTRIBUTE_NORMAL,
							NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		dwWin32errorCode = GetLastError();
		return dwWin32errorCode;
	}

	DWORD dwDataSize = GetFileSize(hFile,NULL);
	DWORD dwId3v2Size = ExtractV2Size(m_head.size) + 10;
	if(dwDataSize < dwId3v2Size)
	{
		return -1;
	}
	dwDataSize -= dwId3v2Size;
	SetFilePointer(hFile,dwId3v2Size,NULL,FILE_BEGIN);

	//obt@̊m
	char *pRawData = (char *)malloc(dwDataSize);
	if(!pRawData)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		return dwWin32errorCode;
	}
	//raw data̓ǂݏo
	if(!ReadFile(hFile,pRawData,dwDataSize,&dwWritten,NULL))
	{
		dwWin32errorCode = GetLastError();
		free(pRawData);
		CloseHandle(hFile);
		return dwWin32errorCode;
	}
	CloseHandle(hFile);

	//==================e|쐬==================
	//e|擾
	if(!GetTempFileName(szTempPath,_T("tms"),0,szTempFile))
	{
		dwWin32errorCode = GetLastError();
		free(pRawData);
		TEDeleteFile(szTempFile);
		return dwWin32errorCode;
	}
	//t@CI[v(wt@Cłɑ݂ĂꍇÃt@C͏㏑܂B)
	hFile = TECreateFile(szTempFile,GENERIC_WRITE|GENERIC_READ,FILE_SHARE_READ,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		dwWin32errorCode = GetLastError();
		free(pRawData);
		TEDeleteFile(szTempFile);
		return dwWin32errorCode;
	}
	//܂Ȃ
	if(SetFilePointer(hFile,0,NULL,FILE_BEGIN) == INVALID_SET_FILE_POINTER)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		free(pRawData);
		TEDeleteFile(szTempFile);
		return dwWin32errorCode;
	}
	//ړɃRs[
	if(WriteFile(hFile,pRawData,dwDataSize,&dwWritten,NULL) == 0)
	{
		dwWin32errorCode = GetLastError();
		CloseHandle(hFile);
		free(pRawData);
		return dwWin32errorCode;
	}
	free(pRawData);
	CloseHandle(hFile);

	//IWit@Cޔ(l[)
	TCHAR szPreFile[MAX_PATH];
	if(!GetTempFileName(szTempPath,_T("tms"),0,szPreFile))
	{
		dwWin32errorCode = GetLastError();
		TEDeleteFile(szTempFile);
		return dwWin32errorCode;
	}
	TEDeleteFile(szPreFile);//蔲(^^;
	if(!TEMoveFile(szFileName,szPreFile))
	{
		dwWin32errorCode = GetLastError();
		TEDeleteFile(szTempFile);
		return dwWin32errorCode;
	}

	//il[
	if(!TEMoveFile(szTempFile,szFileName))
	{
		dwWin32errorCode = GetLastError();
		TEMoveFile(szPreFile,szFileName);
		TEDeleteFile(szTempFile);
		return dwWin32errorCode;
	}

	//IWi폜
	TEDeleteFile(szPreFile);

	Release();

	return dwWin32errorCode;
}

DWORD CId3tagv2::MakeTag(LPCTSTR szFileName)
{
	DWORD	dwWin32errorCode = ERROR_SUCCESS;
	if(m_bEnable)
	{
		return -1;
	}

	size_t dwTotalFrameSize = GetTotalFrameSize();
	//[pfBÖ}]
	size_t dwPaddingSize = ID3V2_PADDING_SIZE;

	//t[o
	unsigned char *pFrameData = (unsigned char *)malloc(dwTotalFrameSize);
	if(!pFrameData)
	{
		dwWin32errorCode = GetLastError();
		return dwWin32errorCode;
	}
	size_t dwFrameDataPtr = 0;
	multimap<DWORD,CId3Frame>::iterator p;
	p = m_frames.begin();
	while(p != m_frames.end())
	{
		CId3Frame *pFrame = &p->second;
		size_t dwSize = pFrame->GetSize();
		DWORD id = pFrame->GetId();
		WORD flags = pFrame->GetFlags();
		WORD flagsBe = ((flags<<8)|(flags>>8));
		unsigned char *data = pFrame->GetData();
		if(m_wVer == 0x0200)
		{
			unsigned char size[3];
			size[2] = dwSize & 0xff;
			size[1] = (dwSize>>8) & 0xff;
			size[0] = (dwSize>>16) & 0xff;
			// id3v2.2
			char v22id[3];
			//v2.3v2.2փt[IDϊ
			v23IDtov22ID((char *)&id,v22id);
			memcpy(&pFrameData[dwFrameDataPtr],&v22id,sizeof(v22id));
			dwFrameDataPtr += sizeof(v22id);
			memcpy(&pFrameData[dwFrameDataPtr],size,sizeof(size));
			dwFrameDataPtr += sizeof(size);
			memcpy(&pFrameData[dwFrameDataPtr],data,dwSize);
			dwFrameDataPtr += dwSize;
		}
		else
		{
			// ID3v2.3-
			unsigned char size[4];
			size[3] = dwSize & 0xff;
			size[2] = (dwSize>>8) & 0xff;
			size[1] = (dwSize>>16) & 0xff;
			size[0] = (dwSize>>24) & 0xff;
			memcpy(&pFrameData[dwFrameDataPtr],&id,sizeof(id));
			dwFrameDataPtr += sizeof(id);
			memcpy(&pFrameData[dwFrameDataPtr],size,sizeof(size));
			dwFrameDataPtr += sizeof(size);
			memcpy(&pFrameData[dwFrameDataPtr],&flagsBe,sizeof(flagsBe));
			dwFrameDataPtr += sizeof(flagsBe);
			memcpy(&pFrameData[dwFrameDataPtr],data,dwSize);
			dwFrameDataPtr += dwSize;
		}
		p++;
	}
	assert(dwFrameDataPtr == dwTotalFrameSize);
	//񓯊
	if(m_bUnSynchronization)
	{
		unsigned char *pEncData = (unsigned char *)malloc(dwTotalFrameSize*2);
		size_t dwEncodeSize = EncodeUnSynchronization(pFrameData,dwTotalFrameSize,pEncData);
//		if(dwEncodeSize != dwTotalFrameSize)
//	2004-09-24 vpeBɔ񓯊XCb`߁A񓯊tO͕KĂ邱Ƃɂ
//	(񓯊ONۑłȂlq̓[U݂ĂȓɌ邽)
		{
			//񓯊tOZbg
			m_head.flag |= 0x80;
			dwTotalFrameSize = dwEncodeSize;
		}
		free(pFrameData);
		pFrameData = pEncData;
	}

	m_bEnable = TRUE;

	HANDLE	hFile	= INVALID_HANDLE_VALUE;
	char*	pRawData = NULL;
	const size_t sztLen	= _tcslen(szFileName);
	TCHAR	szTempPath[MAX_PATH];
	GetTempPath(_countof(szTempPath), szTempPath);
	TCHAR	szPreFile[MAX_PATH];
	TCHAR	szTempFile[MAX_PATH];
	szPreFile[0]	= '\0';
	szTempFile[0]	= '\0';
	try {
		//==================t@Cɕۑ==================
		hFile = TECreateFile(
			szFileName,
			GENERIC_READ,
			FILE_SHARE_READ,
			NULL,
			OPEN_EXISTING,	//wt@C݂ĂȂꍇA֐͎s܂B
			FILE_ATTRIBUTE_NORMAL,
			NULL);
		if (hFile == INVALID_HANDLE_VALUE) {
			throw	GetLastError();
		}

		DWORD dwDataSize = GetFileSize(hFile, NULL);
		//obt@̊m
		pRawData = (char *)malloc(dwDataSize);
		if (!pRawData) {
			throw	GetLastError();
		}
		//raw data̓ǂݏo
		DWORD dwWritten;
		if (!ReadFile(hFile, pRawData, dwDataSize, &dwWritten, NULL)) {
			throw	GetLastError();
		}
		CloseHandle(hFile);
		hFile	= INVALID_HANDLE_VALUE;

		//==================e|쐬==================
		//e|擾
		{
			if (!GetTempFileName(szTempPath, _T("tms"), 0, szTempFile)) {
				throw	GetLastError();
			}
		}

		//t@CI[v(wt@Cłɑ݂ĂꍇÃt@C͏㏑܂B)
		hFile = TECreateFile(szTempFile, GENERIC_WRITE | GENERIC_READ, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hFile == INVALID_HANDLE_VALUE) {
			throw	GetLastError();
		}
		//܂Ȃ
		if (SetFilePointer(hFile, 0, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER) {
			throw	GetLastError();
		}
		//pfBÖXLbv
		const DWORD	dwSkip	= (DWORD)(dwPaddingSize + dwTotalFrameSize + sizeof ID3HEAD);
		if (SetFilePointer(hFile, dwSkip, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER) {
			throw	GetLastError();
		}
		//ړɃRs[
		if (WriteFile(hFile, pRawData, dwDataSize, &dwWritten, NULL) == 0) {
			throw	GetLastError();
		}
		free(pRawData);
		pRawData	= NULL;

		if (SetFilePointer(hFile, 0, NULL, FILE_BEGIN) == INVALID_SET_FILE_POINTER) {
			throw	GetLastError();
		}
		ID3HEAD head;
		m_head.ver[0] = (m_wVer & 0xff00) >> 8;
		m_head.ver[1] = (m_wVer & 0x00ff);
		memcpy(&head, &m_head, sizeof(m_head));
		MakeV2Size((DWORD)(dwPaddingSize + dwTotalFrameSize), head.size);
		if (WriteFile(hFile, &head, sizeof(head), &dwWritten, NULL) == 0) {
			throw	GetLastError();
		}
		memcpy(&m_head, &head, sizeof(head));

		//t[t@Cɏo
		if (!WriteFile(hFile, pFrameData, (DWORD)dwTotalFrameSize, &dwWritten, NULL)) {
			throw	GetLastError();
		}
		free(pFrameData);
		pFrameData	= NULL;

		//pfBÖ0ŃpfBO
		for (int i=0; i < (int)dwPaddingSize; i++) {
			DWORD dwRet;
			unsigned char pad = 0x00;
			if (!WriteFile(hFile, &pad, 1, &dwRet, NULL)) {
				throw	GetLastError();
			}
		}
		CloseHandle(hFile);
		hFile	= INVALID_HANDLE_VALUE;

		//IWit@Cޔ(l[)
		if (!GetTempFileName(szTempPath, _T("tms"), 0, szPreFile)) {
			throw	GetLastError();
		}
		TEDeleteFile(szPreFile);//蔲(^^;
		if (!TEMoveFile(szFileName, szPreFile)) {
			throw	GetLastError();
		}

		//il[
		if (!TEMoveFile(szTempFile, szFileName)) {
			throw	GetLastError();
		}

	}
	catch (DWORD dwError) {
		dwWin32errorCode	= dwError;
		m_bEnable = FALSE;
	}

	//IWi폜
	if (szPreFile[0] != '\0') {
		TEDeleteFile(szPreFile);
	}
	if (szTempFile[0] != '\0') {
		TEDeleteFile(szTempFile);
	}
	if (hFile != INVALID_HANDLE_VALUE) {
		CloseHandle(hFile);
	}
	if (pFrameData) {
		free(pFrameData);
	}
	if (pRawData) {
		free(pRawData);
	}
	return dwWin32errorCode;
}

